ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.22 by root, Wed Dec 15 00:17:48 2010 UTC vs.
Revision 1.75 by root, Tue Aug 1 03:48:59 2023 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in (or to replace in your .staticperlrc)
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9DLCACHE=
9 10
10# perl build variables 11# perl build variables
11MAKE=make 12MAKE=make
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 13PERL_VERSION=http://stableperl.schmorp.de/dist/latest.tar.gz # 5.12.5 and 5.8.9 are good choices for small builds
13PERL_CC=cc 14PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments 15PERL_CONFIGURE="" # additional Configure arguments
15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 16PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 17PERL_OPTIMIZE="-Os" # -Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 18
18ARCH="$(uname -m)" 19ARCH="$(uname -m)"
19 20
20case "$ARCH" in 21#case "$ARCH" in
21 i*86 | x86_64 | amd64 ) 22# i*86 | x86_64 | amd64 )
22 PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64 23# PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
23 case "$ARCH" in 24# case "$ARCH" in
24 i*86 ) 25# i*86 )
25 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only 26# PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
26 ;; 27# ;;
27 esac 28# esac
28 ;; 29# ;;
29esac 30#esac
30 31
31# -Wl,--gc-sections makes it impossible to check for undefined references 32# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 33# for some reason so we need to patch away the "-no" after Configure and before make :/
33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 34# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 35#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LDFLAGS=
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 37PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 38
37# some configuration options for modules 39# some configuration options for modules
38export PERL_MM_USE_DEFAULT=1 40PERL_MM_USE_DEFAULT=1
41PERL_MM_OPT="MAN1PODS= MAN3PODS="
39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 42#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 43#EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
44export PERL_MM_USE_DEFAULT PERL_MM_OPT
41 45
42# which extra modules to install by default from CPAN that are 46# which extra modules to install by default from CPAN that are
43# required by mkbundle 47# required by mkbundle
44STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 48STATICPERL_MODULES="ExtUtils::MakeMaker ExtUtils::CBuilder common::sense Pod::Strip PPI PPI::XS Pod::Usage"
45 49
46# which extra modules you might want to install 50# which extra modules you might want to install
47EXTRA_MODULES="" 51EXTRA_MODULES=""
48 52
49# overridable functions 53# overridable functions
50preconfigure() { : ; } 54preconfigure() { : ; }
55patchconfig() { : ; }
51postconfigure() { : ; } 56postconfigure() { : ; }
52postbuild() { : ; } 57postbuild() { : ; }
58postcpanconfig() { : ; }
53postinstall() { : ; } 59postinstall() { : ; }
54 60
55# now source user config, if any 61# now source user config, if any
56if [ "$STATICPERLRC" ]; then 62if [ "$STATICPERLRC" ]; then
57 . "$STATICPERLRC" 63 . "$STATICPERLRC"
58else 64else
62fi 68fi
63 69
64############################################################################# 70#############################################################################
65# support 71# support
66 72
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}" 73# work around ExtUtils::CBuilder and others
74export CC="$PERL_CC"
75export CFLAGS="$PERL_CFLAGS"
76export LD="$PERL_CC"
77export LDFLAGS="$PERL_LDFLAGS"
78unset LIBS
79
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 80PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69 81
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 82unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
83unset PERL_MB_OPT
71export LC_ALL=C # just to be on the safe side 84LC_ALL=C; export LC_ALL # just to be on the safe side
85
86# prepend PATH - not required by staticperl itself, but might make
87# life easier when working in e.g. "staticperl cpan / look"
88PATH="$PERL_PREFIX/perl/bin:$PATH"
72 89
73# set version in a way that Makefile.PL can extract 90# set version in a way that Makefile.PL can extract
74VERSION=VERSION; eval \ 91VERSION=VERSION; eval \
75$VERSION=0.912 92$VERSION="1.46"
76
77BZ2=bz2
78BZIP2=bzip2
79 93
80fatal() { 94fatal() {
81 printf -- "\nFATAL: %s\n\n" "$*" >&2 95 printf -- "\nFATAL: %s\n\n" "$*" >&2
82 exit 1 96 exit 1
83} 97}
123 137
124############################################################################# 138#############################################################################
125# download/configure/compile/install perl 139# download/configure/compile/install perl
126 140
127clean() { 141clean() {
128 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 142 rm -rf "$STATICPERL/src"
143}
144
145realclean() {
146 rm -f "$PERL_PREFIX/staticstamp.postinstall"
147 rm -f "$PERL_PREFIX/staticstamp.install"
148 rm -f "$STATICPERL/src/perl/staticstamp.configure"
129} 149}
130 150
131fetch() { 151fetch() {
152(
132 rcd "$STATICPERL" 153 rcd "$STATICPERL"
133 154
134 mkdir -p src 155 mkdir -p src
135 rcd src 156 rcd src
136 157
137 if ! [ -d "perl-$PERL_VERSION" ]; then 158 if ! [ -d "perl" ]; then
138 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then 159 rm -rf unpack
160 mkdir -p unpack
139 161
162 case "$PERL_VERSION" in
163 *:* )
164 # url
165 PERLURL="$PERL_VERSION"
166 PERLTAR="$(basename "$PERL_VERSION")"
167 ;;
168 /* )
169 # directory
170 verbose "copying $PERL_VERSION"
171 cp -Rp "$PERL_VERSION/." unpack/.
172 chmod -R u+w unpack
173 mv unpack perl
174 return
175 ;;
176 * )
140 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2" 177 PERLURL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.bz2"
178 PERLTAR=perl-$PERL_VERSION.tar.bz2
179 ;;
180 esac
141 181
182 if ! [ -e "$PERLTAR" ]; then
142 verblock <<EOF 183 verblock <<EOF
143downloading perl 184downloading perl
185
186trying to download from $PERLURL
187
188you can configure a download cache directory via DLCACHE
189in your .staticperlrc to avoid repeated downloads.
190
144to manually download perl yourself, place 191to manually download perl yourself, place a suitable tarball in
145perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 192$DLCACHE/$PERLTAR
146trying $URL
147EOF
148 193
194either curl or wget is required for automatic download.
195curl is tried first, then wget.
196EOF
197
149 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 198 rm -f $PERLTAR~ # just to be on the safe side
150 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 199 { [ "$DLCACHE" ] && cp "$DLCACHE"/$PERLTAR $PERLTAR~ >/dev/null 2>&1; } \
151 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 200 || wget -O $PERLTAR~ "$PERLURL" \
201 || curl -f >$PERLTAR~ "$PERLURL" \
152 || fatal "$URL: unable to download" 202 || fatal "$URL: unable to download"
153 rm -f perl-$PERL_VERSION.tar.$BZ2 203 rm -f $PERLTAR
154 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 204 mv $PERLTAR~ $PERLTAR
205 if [ "$DLCACHE" ]; then
206 mkdir -p "$DLCACHE"
207 cp $PERLTAR "$DLCACHE"/$PERLTAR~$$~ && \
208 mv "$DLCACHE"/$PERLTAR~$$~ "$DLCACHE"/$PERLTAR
209 fi
155 fi 210 fi
156 211
157 verblock <<EOF 212 verblock <<EOF
158unpacking perl 213unpacking perl
159EOF 214EOF
160 215
161 mkdir -p unpack 216 case "$PERLTAR" in
162 rm -rf unpack/perl-$PERL_VERSION 217 *.xz ) UNCOMPRESS="xz -d" ;;
163 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 218 *.lzma ) UNCOMPRESS="lzma -d" ;;
219 *.bz2 ) UNCOMPRESS="bzip2 -d" ;;
220 *.gz ) UNCOMPRESS="gzip -d" ;;
221 *.tar ) UNCOMPRESS="cat" ;;
222 * )
223 fatal "don't know hot to uncompress $PERLTAR,\nonly tar, tar.gz, tar.bz2, tar.lzma and tar.xz are supported."
224 exit 1
225 ;;
226 esac
227
228 <"$PERLTAR" $UNCOMPRESS -d | ( cd unpack && tar xf - ) \
164 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 229 || fatal "$PERLTAR: error during unpacking"
165 chmod -R u+w unpack/perl-$PERL_VERSION 230
166 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 231 if [ -d unpack/*/ ]; then
232 chmod -R u+w unpack/*/
233 mv unpack/*/ perl
167 rmdir -p unpack 234 rmdir -p unpack
235 else
236 fatal "unpacking $PERLTAR did not result in a single directory, don't know how to handle this"
237 fi
238
239 rm "$PERLTAR"
168 fi 240 fi
241) || exit
169} 242}
170 243
171# similar to GNU-sed -i or perl -pi 244# similar to GNU-sed -i or perl -pi
172sedreplace() { 245sedreplace() {
173 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 246 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
200EOF 273EOF
201 exit 1 274 exit 1
202} 275}
203 276
204configure() { 277configure() {
278(
205 fetch 279 fetch
206 280
207 rcd "$STATICPERL/src/perl-$PERL_VERSION" 281 rcd "$STATICPERL/src/perl"
208 282
209 [ -e staticstamp.configure ] && return 283 [ -e staticstamp.configure ] && return
210 284
211 verblock <<EOF 285 verblock <<EOF
212configuring $STATICPERL/src/perl-$PERL_VERSION 286configuring $STATICPERL/src/perl
213EOF 287EOF
214 288
215 rm -f "$PERL_PREFIX/staticstamp.install" 289 rm -f "$PERL_PREFIX/staticstamp.install"
216 290
217 "$MAKE" distclean >/dev/null 2>&1 291 "$MAKE" distclean >/dev/null 2>&1
218 292
293 sedreplace '/^#define SITELIB/d' config_h.SH
294
219 # I hate them 295 # I hate them for this
220 grep -q -- -fstack-protector Configure && \ 296 grep -q -- -fstack-protector Configure && \
221 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 297 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
222 298
223 preconfigure 299 # what did that bloke think
300 grep -q -- usedl=.define hints/darwin.sh && \
301 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
302
303 preconfigure || fatal "preconfigure hook failed"
224 304
225# trace configure \ 305# trace configure \
226 sh Configure -Duselargefiles \ 306 sh Configure -Duselargefiles \
227 -Uuse64bitint \ 307 -Uuse64bitint \
228 -Dusemymalloc=n \ 308 -Dusemymalloc=n \
230 -Uusethreads \ 310 -Uusethreads \
231 -Uuseithreads \ 311 -Uuseithreads \
232 -Uusemultiplicity \ 312 -Uusemultiplicity \
233 -Uusesfio \ 313 -Uusesfio \
234 -Uuseshrplib \ 314 -Uuseshrplib \
315 -Uinstallusrbinperl \
235 -A ccflags=" $PERL_CCFLAGS" \ 316 -A ccflags=" $PERL_CCFLAGS" \
236 -Dcc="$PERL_CC" \ 317 -Dcc="$PERL_CC" \
237 -Doptimize="$PERL_OPTIMIZE" \ 318 -Doptimize="$PERL_OPTIMIZE" \
238 -Dldflags="$PERL_LDFLAGS" \ 319 -Dldflags="$PERL_LDFLAGS" \
239 -Dlibs="$PERL_LIBS" \ 320 -Dlibs="$PERL_LIBS" \
242 -Dprivlib="$PERL_PREFIX/lib" \ 323 -Dprivlib="$PERL_PREFIX/lib" \
243 -Darchlib="$PERL_PREFIX/lib" \ 324 -Darchlib="$PERL_PREFIX/lib" \
244 -Uusevendorprefix \ 325 -Uusevendorprefix \
245 -Dsitelib="$PERL_PREFIX/lib" \ 326 -Dsitelib="$PERL_PREFIX/lib" \
246 -Dsitearch="$PERL_PREFIX/lib" \ 327 -Dsitearch="$PERL_PREFIX/lib" \
247 -Usitelibexp \
248 -Uman1dir \ 328 -Uman1dir \
249 -Uman3dir \ 329 -Uman3dir \
250 -Usiteman1dir \ 330 -Usiteman1dir \
251 -Usiteman3dir \ 331 -Usiteman3dir \
252 -Dpager=/usr/bin/less \ 332 -Dpager=/usr/bin/less \
253 -Demail="$EMAIL" \ 333 -Demail="$EMAIL" \
254 -Dcf_email="$EMAIL" \ 334 -Dcf_email="$EMAIL" \
255 -Dcf_by="$EMAIL" \ 335 -Dcf_by="$EMAIL" \
256 $PERL_CONFIGURE \ 336 $PERL_CONFIGURE \
257 -Duseperlio \ 337 -Duseperlio \
338 -Uversiononly \
258 -dE || configure_failure 339 -dE || configure_failure
259 340
260 sedreplace ' 341 sedreplace '
261 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 342 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
262 s/ *-fno-stack-protector */ /g 343 s/ *-fno-stack-protector */ /g
263 ' config.sh 344 ' config.sh
264 345
346 patchconfig || fatal "patchconfig hook failed"
347
265 sh Configure -S || fatal "Configure -S failed" 348 sh Configure -S || fatal "Configure -S failed"
266 349
267 postconfigure || fatal "postconfigure hook failed" 350 postconfigure || fatal "postconfigure hook failed"
268 351
269 touch staticstamp.configure 352 : > staticstamp.configure
353) || exit
354}
355
356write_shellscript() {
357 {
358 echo "#!/bin/sh"
359 echo "STATICPERL=\"$STATICPERL\""
360 echo "PERL_PREFIX=\"$PERL_PREFIX\""
361 echo "MAKE=\"$MAKE\""
362 cat
363 } >"$PERL_PREFIX/bin/$1"
364 chmod 755 "$PERL_PREFIX/bin/$1"
270} 365}
271 366
272build() { 367build() {
368(
273 configure 369 configure
274 370
275 rcd "$STATICPERL/src/perl-$PERL_VERSION" 371 rcd "$STATICPERL/src/perl"
276 372
277 verblock <<EOF 373 verblock <<EOF
278building $STATICPERL/src/perl-$PERL_VERSION 374building $STATICPERL/src/perl
279EOF 375EOF
280 376
281 rm -f "$PERL_PREFIX/staticstamp.install" 377 rm -f "$PERL_PREFIX/staticstamp.install"
282 378
283 "$MAKE" || fatal "make: error while building perl" 379 "$MAKE" || fatal "make: error while building perl"
284 380
285 postbuild || fatal "postbuild hook failed" 381 postbuild || fatal "postbuild hook failed"
382) || exit
383}
384
385_postinstall() {
386 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
387 NOCHECK_INSTALL=+
388 instcpan $STATICPERL_MODULES
389 [ "$EXTRA_MODULES" ] && instcpan $EXTRA_MODULES
390
391 postinstall || fatal "postinstall hook failed"
392
393 : > "$PERL_PREFIX/staticstamp.postinstall"
394 fi
286} 395}
287 396
288install() { 397install() {
398(
289 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then 399 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
290 build 400 build
291 401
292 verblock <<EOF 402 verblock <<EOF
293installing $STATICPERL/src/perl-$PERL_VERSION 403installing $STATICPERL/src/perl
294to $PERL_PREFIX 404to $PERL_PREFIX
295EOF 405EOF
296 406
297 ln -sf "perl/bin/" "$STATICPERL/bin" 407 ln -sf "perl/bin/" "$STATICPERL/bin"
298 ln -sf "perl/lib/" "$STATICPERL/lib" 408 ln -sf "perl/lib/" "$STATICPERL/lib"
299 409
410 mkdir "$STATICPERL/patched"
411
300 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 412 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
301 rm -rf "$PERL_PREFIX" # by this rm -rf 413 rm -rf "$PERL_PREFIX" # by this rm -rf
302 414
415 rcd "$STATICPERL/src/perl"
416
303 "$MAKE" install || fatal "make install: error while installing" 417 "$MAKE" install || fatal "make install: error while installing"
304 418
305 rcd "$PERL_PREFIX" 419 rcd "$PERL_PREFIX"
306 420
307 # create a "make install" replacement for CPAN 421 # create a "make install" replacement for CPAN
308 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 422 write_shellscript SP-make-make <<'end_of_make'
309"$MAKE" || exit 423#CAT make-make.sh
424end_of_make
310 425
311if find blib/arch/auto -type f | grep -q -v .exists; then 426 # create a "make install" replacement for CPAN
312 echo Probably an XS module, rebuilding perl 427 write_shellscript SP-make-install-make <<'end_of_make_install_make'
313 if "$MAKE" perl; then 428#CAT make-install-make.sh
314 mv perl "$PERL_PREFIX"/bin/perl~ \ 429end_of_make_install_make
315 && rm -f "$PERL_PREFIX"/bin/perl \
316 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
317 "$MAKE" -f Makefile.aperl map_clean
318 else
319 "$MAKE" -f Makefile.aperl map_clean
320 exit 1
321 fi
322fi
323 430
324"$MAKE" install UNINST=1 431 # create a "patch modules" helper
325EOF 432 write_shellscript SP-patch-postinstall <<'end_of_patch_postinstall'
326 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 433#CAT patch-postinstall.sh
434end_of_patch_postinstall
327 435
436 # immediately use it
437 "$PERL_PREFIX/bin/SP-patch-postinstall"
438
328 # trick CPAN into avoiding ~/.cpan completely 439 # help to trick CPAN into avoiding ~/.cpan completely
329 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 440 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
330 441
442 # we call cpan with -MCPAN::MyConfig in this script, which
443 # is strictly unnecessary as we have to patch CPAN anyway,
444 # so consider it "for good measure".
331 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 445 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
332 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 446 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
447 CPAN::Shell->o (conf => pushy_https => "0");
333 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 448 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
334 CPAN::Shell->o (conf => q<init>); 449 CPAN::Shell->o (conf => q<init>);
335 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 450 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
336 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 451 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
337 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 452 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
338 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 453 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
339 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 454 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
455 CPAN::Shell->o (conf => q<makepl_arg>, "MAP_TARGET=perl");
456 CPAN::Shell->o (conf => q<make>, "'"$PERL_PREFIX"'/bin/SP-make-make");
340 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 457 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
341 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 458 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
342 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 459 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<yes>);
460 CPAN::Shell->o (conf => q<recommends_policy>, q<0>);
461 CPAN::Shell->o (conf => q<suggests_policy>, q<0>);
462 CPAN::Shell->o (conf => q<prefer_installer>, q<EUMM>);
343 CPAN::Shell->o (conf => q<commit>); 463 CPAN::Shell->o (conf => q<commit>);
344 ' || fatal "error while initialising CPAN" 464 ' || fatal "error while initialising CPAN"
345 465
466 postcpanconfig
467
346 touch "$PERL_PREFIX/staticstamp.install" 468 : > "$PERL_PREFIX/staticstamp.install"
347 fi 469 fi
348 470
471 _postinstall
472) || exit
473}
474
475import() {
476(
477 IMPORT="$1"
478
479 rcd "$STATICPERL"
480
349 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then 481 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
350 NOCHECK_INSTALL=+ 482 verblock <<EOF
351 instcpan $STATICPERL_MODULES 483import perl from $IMPORT to $STATICPERL
352 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 484EOF
353 485
354 postinstall || fatal "postinstall hook failed" 486 rm -rf bin cpan lib patched perl src
487 mkdir -m 755 perl perl/bin
488 ln -s perl/bin/ bin
489 ln -s "$IMPORT" perl/bin/
355 490
491 echo "$IMPORT" > "$PERL_PREFIX/.import"
492
356 touch "$PERL_PREFIX/staticstamp.postinstall" 493 : > "$PERL_PREFIX/staticstamp.install"
357 fi 494 fi
495
496 _postinstall
497) || exit
358} 498}
359 499
360############################################################################# 500#############################################################################
361# install a module from CPAN 501# install a module from CPAN
362 502
363instcpan() { 503instcpan() {
364 [ $NOCHECK_INSTALL ] || install 504 [ $NOCHECK_INSTALL ] || install
365 505
366 verblock <<EOF 506 verblock <<EOF
367installing modules from CPAN 507installing modules from CPAN
368$@ 508$*
369EOF 509EOF
370 510
371 for mod in "$@"; do 511 MYCONFIG=
372 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 512 [ -e "$PERL_PREFIX/.import" ] || MYCONFIG=-MCPAN::MyConfig
373 || fatal "$mod: unable to install from CPAN" 513
374 done 514 "$PERL_PREFIX"/bin/perl $MYCONFIG -MCPAN -e 'notest (install => $_) for @ARGV' -- "$@" | tee "$STATICPERL/instcpan.log"
515
516 if grep -q " -- NOT OK\$" "$STATICPERL/instcpan.log"; then
517 fatal "failure while installing modules from CPAN ($*)"
518 fi
375 rm -rf "$STATICPERL/build" 519 rm -f "$STATICPERL/instcpan.log"
376} 520}
377 521
378############################################################################# 522#############################################################################
379# install a module from unpacked sources 523# install a module from unpacked sources
380 524
381instsrc() { 525instsrc() {
382 [ $NOCHECK_INSTALL ] || install 526 [ $NOCHECK_INSTALL ] || install
383 527
384 verblock <<EOF 528 verblock <<EOF
385installing modules from source 529installing modules from source
386$@ 530$*
387EOF 531EOF
388 532
389 for mod in "$@"; do 533 for mod in "$@"; do
390 echo 534 echo
391 echo $mod 535 echo $mod
393 rcd $mod 537 rcd $mod
394 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1 538 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
395 "$MAKE" distclean >/dev/null 2>&1 539 "$MAKE" distclean >/dev/null 2>&1
396 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 540 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
397 "$MAKE" || fatal "$mod: error building module" 541 "$MAKE" || fatal "$mod: error building module"
398 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 542 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
399 "$MAKE" distclean >/dev/null 2>&1 543 "$MAKE" distclean >/dev/null 2>&1
400 exit 0 544 exit 0
401 ) || exit $? 545 ) || exit $?
402 done 546 done
403} 547}
429catmkbundle() { 573catmkbundle() {
430 { 574 {
431 read dummy 575 read dummy
432 echo "#!$PERL_PREFIX/bin/perl" 576 echo "#!$PERL_PREFIX/bin/perl"
433 cat 577 cat
434 } <<'MKBUNDLE' 578 } <<'end_of_mkbundle'
435#CAT mkbundle 579#CAT mkbundle
436MKBUNDLE 580end_of_mkbundle
437} 581}
438 582
439bundle() { 583bundle() {
584 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
440 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 585 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
441 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 586 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
442 CACHE="$STATICPERL/cache" 587 CACHE="$STATICPERL/cache"
443 mkdir -p "$CACHE" 588 mkdir -p "$CACHE"
444 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 589 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
452 command="${1#--}"; shift 597 command="${1#--}"; shift
453 case "$command" in 598 case "$command" in
454 version ) 599 version )
455 echo "staticperl version $VERSION" 600 echo "staticperl version $VERSION"
456 ;; 601 ;;
457 fetch | configure | build | install | clean | distclean) 602 fetch | configure | build | install | clean | realclean | distclean )
458 ( "$command" ) || exit 603 ( "$command" ) || exit
604 ;;
605 import )
606 ( import "$1" ) || exit
607 shift
459 ;; 608 ;;
460 instsrc ) 609 instsrc )
461 ( instsrc "$@" ) || exit 610 ( instsrc "$@" ) || exit
462 exit 611 exit
463 ;; 612 ;;
464 instcpan ) 613 instcpan )
465 ( instcpan "$@" ) || exit 614 ( instcpan "$@" ) || exit
466 exit 615 exit
467 ;; 616 ;;
617 perl )
618 ( install ) || exit
619 exec "$PERL_PREFIX/bin/perl" "$@"
620 exit
621 ;;
468 cpan ) 622 cpan )
469 ( install ) || exit 623 ( install ) || exit
624 PERL="$PERL_PREFIX/bin/perl"
625 export PERL
470 "$PERL_PREFIX/bin/cpan" "$@" 626 exec "$PERL_PREFIX/bin/cpan" "$@"
471 exit 627 exit
472 ;; 628 ;;
473 mkbundle ) 629 mkbundle )
474 ( install ) || exit 630 ( install ) || exit
475 bundle "$@" 631 bundle "$@"

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines